// Copyright © 2015 Vaqtincha

/********************** V.I.P Custom Weapons ****************
*
*	Credits:
*	ConnorMcLeod for cstrike_pdatas
*	Safety1st for plugin "Prize Knife"
*************************************************************/


#include <amxmodx>
#include <fakemeta>
#include <hamsandwich>

#define PLUGIN_NAME 	"V.I.P Custom KNIFE"	// don't change this!
#define PLUGIN_VERSION 	"1.0.0"					// version for "V.I.P Custom Weapons" 
#define PLUGIN_AUTHOR 	"Vaqtincha" 			

#define get_weapon_owner(%1)		get_pdata_cbase(%1, m_pPlayer, XO_WEAPON)

#if AMXX_VERSION_NUM < 183
	#define HasShield(%1)		(get_pdata_int(%1, m_iUserPrefs, XO_PLAYER) & m_bHasShield)
#else
	#define HasShield(%1)		get_pdata_bool(%1, m_bHasShield)
#endif

#define IsPlayer(%0)	( 1 <= (%0) <= giMaxPlayers )
#define MAX_PLAYERS 32

/*-----------------------------------------------------------------*/
// #define SHIELD_SUPPORT
new const weapon_name[] = "weapon_knife"
new const weapon_id = CSW_KNIFE

new const V_MODEL[] = "models/custom/v_knife.mdl"	// view weapon model
new const P_MODEL[] = "models/custom/p_knife.mdl"	// player weapon model
#if defined SHIELD_SUPPORT
new const V_SHIELD_MODEL[] = "models/custom/v_shield_knife.mdl"
new const P_SHIELD_MODEL[] = "models/custom/p_shield_knife.mdl"
#endif
/*-----------------------------------------------------------------*/

new bool:g_bAccess[MAX_PLAYERS+1]
static flagaccess
new Float:damage
new giMaxPlayers, block_map

	// Offsets
#if AMXX_VERSION_NUM < 183
	const m_bHasShield = 1<<24
	const m_iUserPrefs = 510
#else
	const m_bHasShield = 2043
#endif
const m_pPlayer  = 41
const XO_WEAPON = 4
const XO_PLAYER = 5


public plugin_init()
{
	new mapname[6]
	get_mapname(mapname, charsmax(mapname))
	if(equali(mapname, "35hp_") || equali(mapname, "ka_", 3) || equali(mapname, "1hp_", 4))
	{
		block_map = true
	}
	register_plugin(PLUGIN_NAME, PLUGIN_VERSION, PLUGIN_AUTHOR)
	loadconfig()
	giMaxPlayers = get_maxplayers()

	RegisterHam(Ham_Spawn, "player", "playerspawn_post", 1)
	RegisterHam(Ham_Item_Deploy, weapon_name, "fw_ItemDeploy_Weap_Post", 1)
	#if defined SHIELD_SUPPORT
	RegisterHam(Ham_Weapon_SecondaryAttack, weapon_name, "fw_Weapon_SecondaryAttack_Post", 1)
	#endif
	if(!block_map)
	{
		RegisterHam(Ham_TakeDamage, "player", "fw_TakeDamage_Pre", 0)
	}
}

public loadconfig()
{
	new ConfigFile[64], szMsg[128]	// "addons/amxmodx/configs/vip_custom.ini" 37
	get_localinfo("amxx_configsdir", ConfigFile, charsmax(ConfigFile))
	add(ConfigFile, charsmax(ConfigFile), "/vip_custom.ini")
	if( !file_exists(ConfigFile) )
	{
		formatex( szMsg, charsmax(szMsg), "%s Config File Not Found!", PLUGIN_NAME )
		set_fail_state(szMsg)
		return
	}
	
	new fp = fopen(ConfigFile, "rt")
	if( fp )
	{
		new Datas[86], Setting[24], Value[15]
		while( !feof(fp) )
		{
			fgets(fp, Datas, charsmax(Datas))
			trim(Datas)
			if(!Datas[0] || Datas[0] == ';' || Datas[0] == '#' || Datas[0] == '/'|| Datas[0] == '[')
			{
				continue
			}
			new Sign[3]
			parse(Datas, Setting, charsmax(Setting), Sign, charsmax(Sign), Value, charsmax(Value))
			if( equali(Setting, "flag_access")){
				flagaccess = read_flags(Value)
			}else if( equali(Setting, "knife_damage")){
				damage = str_to_float(Value)
			}
		}
		formatex( szMsg, charsmax(szMsg), "%s Config Successfully Loaded!", PLUGIN_NAME )
		server_print(szMsg)
	}
}

public plugin_precache() 
{
	precache_model(V_MODEL)
	precache_model(P_MODEL)
	#if defined SHIELD_SUPPORT
	precache_model(V_SHIELD_MODEL)
	precache_model(P_SHIELD_MODEL)
	#endif
}

public client_putinserver(id)
{
	g_bAccess[id] = get_user_flags(id) & flagaccess ? true : false
}

public playerspawn_post(id)
{
	g_bAccess[id] = get_user_flags(id) & flagaccess ? true : false
}

public fw_ItemDeploy_Weap_Post(ent)
{
	new iPlayer = get_weapon_owner(ent)
	if(iPlayer > 0 && g_bAccess[iPlayer])
	{
		#if defined SHIELD_SUPPORT
		if(HasShield(iPlayer))
		{
			set_pev(iPlayer, pev_viewmodel2, V_SHIELD_MODEL)
			set_pev(iPlayer, pev_weaponmodel2, P_SHIELD_MODEL)
		}
		else{
			set_pev(iPlayer, pev_viewmodel2, V_MODEL)
			set_pev(iPlayer, pev_weaponmodel2, P_MODEL)
		}
		#else
		set_pev(iPlayer, pev_viewmodel2, V_MODEL)
		set_pev(iPlayer, pev_weaponmodel2, P_MODEL)
		#endif
	}
	return HAM_IGNORED
}
#if defined SHIELD_SUPPORT
public fw_Weapon_SecondaryAttack_Post(ent)
{
	new iPlayer = get_weapon_owner(ent)
	if(iPlayer > 0 && g_bAccess[iPlayer] && HasShield(iPlayer))
	{
		set_pev(iPlayer, pev_weaponmodel2, P_SHIELD_MODEL)
	}
}
#endif
public fw_TakeDamage_Pre( victim, inflictor, attacker, Float:fdamage, damagebits )
{
	if( !IsPlayer(attacker)||get_user_weapon(attacker) != weapon_id)
		return HAM_IGNORED

	if(g_bAccess[attacker] && attacker == inflictor)
	{
		SetHamParamFloat( 4, fdamage * damage)
		return HAM_HANDLED
	}
	return HAM_IGNORED
}
